package org.vendor.tftp.tool;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.SocketException;
import java.util.HashSet;
import java.util.Iterator;
import org.apache.commons.net.tftp.TFTPPacket;
import org.apache.commons.net.tftp.TFTPPacketException;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.vendor.tftp.common.TFTPCommon;
import org.vendor.tftp.tool.TFTPTransfer;

public class TFTPService implements Runnable {
  private Logger logger = LogManager.getLogger(org.vendor.tftp.tool.TFTPService.class);
  
  public static final org.vendor.tftp.tool.TFTPService TFTPSERVICE = new org.vendor.tftp.tool.TFTPService();
  
  public static final String DEFAULT_TFTP_PORT_CMD = "cmd.exe /c netstat -aon|findstr :";
  
  public static final String DEFAULT_TFTP_PORT_LINUX_CMD = "bin/sh -c netstat -tunlp|grep :";
  
  public static final String[] DEFAULT_TFTP_PORT_LINUX_CMD_LIST = new String[] { "/bin/sh", "-c", "netstat -tunlp|grep " };
  
  public static final String PORT_LINUX_CMD = "netstat -tunlp|grep ";
  
  public static final String DEFAULT_TFTP_STRING_PORT = ":69";
  
  private static int winSizeBlockCount = 1;
  
  private static int settingRetransmit = 5;
  
  private static int tftpTimeout = 5;
  
  private static boolean winSizeOpen = false;
  
  private static boolean settingIgnoreBlockAck = true;
  
  private static boolean isUsb2EtherNet = false;
  
  private static int tftpBlockSize = 1468;
  
  private final HashSet<TFTPTransfer> transfers = new HashSet<>();
  
  private volatile boolean shutdownServer = false;
  
  private TFTPCommon serverTftp;
  
  private File serverDirectory;
  
  public static int getTftpBlockSize() {
    return tftpBlockSize;
  }
  
  public static void setTftpBlockSize(int tftpBlockSize) {
    org.vendor.tftp.tool.TFTPService.tftpBlockSize = tftpBlockSize;
  }
  
  public static boolean isUsb2EtherNet() {
    return isUsb2EtherNet;
  }
  
  public static void setUsb2EtherNet(boolean isUsb2EtherNet) {
    org.vendor.tftp.tool.TFTPService.isUsb2EtherNet = isUsb2EtherNet;
  }
  
  public File getServerDirectory() {
    return this.serverDirectory;
  }
  
  public static int getWinSizeBlockCount() {
    return winSizeBlockCount;
  }
  
  public static void setWinSizeBlockCount(int winSizeBlockCount) {
    org.vendor.tftp.tool.TFTPService.winSizeBlockCount = winSizeBlockCount;
  }
  
  public static int getSettingRetransmit() {
    return settingRetransmit;
  }
  
  public static void setSettingRetransmit(int settingRetransmit) {
    org.vendor.tftp.tool.TFTPService.settingRetransmit = settingRetransmit;
  }
  
  public static boolean isWinSizeOpen() {
    return winSizeOpen;
  }
  
  public static void setWinSizeOpen(boolean winSizeOpen) {
    org.vendor.tftp.tool.TFTPService.winSizeOpen = winSizeOpen;
  }
  
  public static boolean isSettingIgnoreBlockAck() {
    return settingIgnoreBlockAck;
  }
  
  public static void setSettingIgnoreBlockAck(boolean settingIgnoreBlockAck) {
    org.vendor.tftp.tool.TFTPService.settingIgnoreBlockAck = settingIgnoreBlockAck;
  }
  
  public static int getTftpTimeout() {
    return tftpTimeout;
  }
  
  public static void setTftpTimeout(int tftpTimeout) {
    if (tftpTimeout > org.vendor.tftp.tool.TFTPService.tftpTimeout)
      org.vendor.tftp.tool.TFTPService.tftpTimeout = tftpTimeout; 
  }
  
  public void setServerDirectory(File serverDirectory) {
    this.serverDirectory = serverDirectory;
  }
  
  private boolean start = false;
  
  public boolean isStart() {
    return this.start;
  }
  
  private int maxTimeoutRetries = 3;
  
  private int socketTimeout;
  
  private Thread serverThread;
  
  public boolean start(File serverDirectory, InetAddress ipAddress, int port) throws SocketException {
    this.serverDirectory = serverDirectory;
    synchronized (this.transfers) {
      this.socketTimeout = this.serverTftp.getDefaultTimeout();
    } 
    this.serverTftp.setDefaultTimeout(0);
    try {
      this.serverTftp.open(port, ipAddress);
    } catch (SocketException e) {
      e.printStackTrace();
      return false;
    } 
    this.serverThread = new Thread(this, "Tftp Server");
    this.serverThread.setDaemon(true);
    this.serverThread.start();
    return this.start = true;
  }
  
  public boolean start(File serverDirectory, InetAddress ipAddress, String cmd, int port) throws SocketException {
    if (!checkPort(cmd, port))
      return false; 
    return start(serverDirectory, ipAddress, port);
  }
  
  public boolean checkPort(String cmd, int port) throws SocketException {
    if (cmd.equals("cmd.exe /c netstat -aon|findstr :")) {
      if (isPortUsing("cmd.exe /c netstat -aon|findstr :" + port, port))
        return false; 
    } else {
      DEFAULT_TFTP_PORT_LINUX_CMD_LIST[2] = "netstat -tunlp|grep " + String.valueOf(port);
      if (isPortUsing(DEFAULT_TFTP_PORT_LINUX_CMD_LIST, port))
        return false; 
    } 
    return true;
  }
  
  private boolean checkUsingPort(BufferedReader br, int port) throws IOException {
    while (true) {
      String readLine = br.readLine();
      if (readLine == null)
        return false; 
      String[] resultList = readLine.split(" ");
      for (String str : resultList) {
        if (str != null)
          if (str.trim().endsWith(":" + port)) {
            this.logger.info("port :" + str);
            return true;
          }  
      } 
    } 
  }
  
  public boolean isPortUsing(String[] cmdList, int port) {
    BufferedReader br = null;
    Process process = null;
    try {
      process = Runtime.getRuntime().exec(cmdList);
      br = new BufferedReader(new InputStreamReader(process.getInputStream()));
      if (checkUsingPort(br, port))
        return true; 
    } catch (IOException iOException) {
    
    } finally {
      if (br != null)
        try {
          br.close();
        } catch (IOException iOException) {} 
      if (process != null) {
        process.destroy();
        process = null;
      } 
    } 
    return false;
  }
  
  public boolean isPortUsing(String cmd, int port) {
    BufferedReader bufferedReader = null;
    Process process = null;
    try {
      process = Runtime.getRuntime().exec(cmd);
      bufferedReader = new BufferedReader(new InputStreamReader(process.getInputStream()));
      while (true) {
        String readLine = bufferedReader.readLine();
        if (readLine == null)
          return false; 
        String[] resultList = readLine.split(" ");
        for (String str : resultList) {
          if (str != null)
            if (str.trim().endsWith("" + port)) {
              this.logger.info("port :" + str);
              System.out.println("port :str");
              return true;
            }  
        } 
      } 
    } catch (IOException iOException) {
    
    } finally {
      try {
        if (bufferedReader != null)
          bufferedReader.close(); 
      } catch (IOException iOException) {}
      if (process != null) {
        process.destroy();
        process = null;
      } 
    } 
    return false;
  }
  
  public void stop() {
    shutdown();
    this.start = false;
  }
  
  public TFTPService() {
    this.serverTftp = new TFTPCommon();
  }
  
  protected void finalize() throws Throwable {
    shutdown();
  }
  
  public void run() {
    try {
      while (!this.shutdownServer) {
        try {
          TFTPPacket tftpPacket = this.serverTftp.receive();
          synchronized (this.transfers) {
            TFTPTransfer tt = new TFTPTransfer(tftpPacket, this.socketTimeout, this.maxTimeoutRetries, this.serverDirectory, this.transfers);
            this.logger.info("TFTPTransfer run");
            this.logger.info("socketTimeout: " + this.socketTimeout);
            this.logger.info("MaxTimeoutRetries: " + this.maxTimeoutRetries);
            this.logger.info("ServerDirectory: " + this.serverDirectory);
            this.transfers.add(tt);
            Thread thread = new Thread((Runnable)tt);
            thread.setDaemon(true);
            thread.start();
            this.logger.info("TFTPTransfer Thread start.");
          } 
        } catch (IOException e) {
          if (!this.shutdownServer)
            this.logger.error("Unexpected Error in TFTP Server - Server shut down! + " + e.getMessage()); 
        } 
      } 
    } catch (TFTPPacketException e) {
      if (!this.shutdownServer)
        this.logger.error("Unexpected Error in TFTP Server - Server shut down! + " + e); 
    } finally {
      this.shutdownServer = true;
      if (this.serverTftp != null && this.serverTftp.isOpen())
        this.serverTftp.close(); 
      this.logger.info("serverTftp: close.");
    } 
  }
  
  public void shutdown() {
    this.logger.info("tftp execute server stop.");
    this.shutdownServer = true;
    synchronized (this.transfers) {
      Iterator<TFTPTransfer> it = this.transfers.iterator();
      while (it.hasNext())
        ((TFTPTransfer)it.next()).shutdown(); 
    } 
    try {
      this.serverTftp.close();
    } catch (RuntimeException e) {
      e.printStackTrace();
    } 
    try {
      if (this.serverThread != null)
        this.serverThread.join(); 
    } catch (InterruptedException e) {
      e.printStackTrace();
    } 
    this.shutdownServer = false;
    this.logger.info("tftp server stop.");
  }
}
